config/urls.py
from django.conf import settings
from django.conf.urls import include
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import re_path
from django.views import defaults as default_views
from django.views.generic import TemplateView

from django_structlog_demo_project.home import api_views, ninja_views, views


def uncaught_exception_view(request):
    raise Exception("Uncaught Exception")


urlpatterns = [
    re_path(r"^$", TemplateView.as_view(template_name="pages/home.html"), name="home"),
    re_path(
        r"^success_task$", views.enqueue_successful_task, name="enqueue_successful_task"
    ),
    re_path(r"^failing_task$", views.enqueue_failing_task, name="enqueue_failing_task"),
    re_path(r"^nesting_task$", views.enqueue_nesting_task, name="enqueue_nesting_task"),
    re_path(r"^unknown_task$", views.enqueue_unknown_task, name="enqueue_unknown_task"),
    re_path(
        r"^rejected_task$", views.enqueue_rejected_task, name="enqueue_rejected_task"
    ),
    re_path(r"^raise_exception", views.raise_exception, name="raise_exception"),
    re_path(
        r"^standard_logger", views.log_with_standard_logger, name="standard_logger"
    ),
    re_path(r"^async_view", views.async_view, name="async_view"),
    re_path(r"^api_view$", api_views.home_api_view, name="api_view"),
    re_path(
        r"^about/", TemplateView.as_view(template_name="pages/about.html"), name="about"
    ),
    re_path(r"^revoke_task", views.revoke_task, name="revoke_task"),
    re_path(
        r"^async_streaming_view",
        views.async_streaming_view,
        name="async_streaming_view",
    ),
    re_path(
        r"^sync_streaming_view", views.sync_streaming_view, name="sync_streaming_view"
    ),
    # Django Admin, use {% url 'admin:index' %}
    re_path(settings.ADMIN_URL, admin.site.urls),
    # User management
    re_path(
        r"^users/",
        include("django_structlog_demo_project.users.urls", namespace="users"),
    ),
    re_path(r"^accounts/", include("allauth.urls")),
    re_path("^ninja/", ninja_views.api.urls),
    # Your stuff: custom urls includes go here
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    urlpatterns += [
        re_path(
            r"^400/",
            default_views.bad_request,
            kwargs={"exception": Exception("Bad Request!")},
        ),
        re_path(
            r"^403/",
            default_views.permission_denied,
            kwargs={"exception": Exception("Permission Denied")},
        ),
        re_path(
            r"^404/",
            default_views.page_not_found,
            kwargs={"exception": Exception("Page not Found")},
        ),
        re_path(r"^500/", default_views.server_error),
        re_path(r"^uncaught_exception/", uncaught_exception_view),
    ]

django_structlog_demo_project/users/urls.py
from django.urls import re_path

from django_structlog_demo_project.users.views import (
    user_detail_view,
    user_list_view,
    user_redirect_view,
    user_update_view,
)

app_name = "users"
urlpatterns = [
    re_path(r"^$", view=user_list_view, name="list"),
    re_path(r"~redirect/", view=user_redirect_view, name="redirect"),
    re_path(r"~update/", view=user_update_view, name="update"),
    re_path(r"^(?P<username>(\w|\.)+)/", view=user_detail_view, name="detail"),
]

django_structlog_demo_project/users/models.py
from django.contrib.auth.models import AbstractUser
from django.db.models import CharField
from django.urls import reverse
from django.utils.translation import gettext_lazy as _


class User(AbstractUser):
    # First Name and Last Name do not cover name patterns
    # around the globe.
    name = CharField(_("Name of User"), blank=True, max_length=255)

    def get_absolute_url(self):
        return reverse("users:detail", kwargs={"username": self.username})

django_structlog_demo_project/users/forms.py
from django.contrib.auth import forms, get_user_model
from django.core.exceptions import ValidationError
from django.utils.translation import gettext_lazy as _

User = get_user_model()


class UserChangeForm(forms.UserChangeForm):
    class Meta(forms.UserChangeForm.Meta):
        model = User


class UserCreationForm(forms.UserCreationForm):
    error_message = forms.UserCreationForm.error_messages.update(
        {"duplicate_username": _("This username has already been taken.")}
    )

    class Meta(forms.UserCreationForm.Meta):
        model = User

    def clean_username(self):
        username = self.cleaned_data["username"]

        try:
            User.objects.get(username=username)
        except User.DoesNotExist:
            return username

        raise ValidationError(self.error_messages["duplicate_username"])

django_structlog_demo_project/home/views.py
import asyncio
import logging
import time

import structlog
from django.http import HttpResponse, StreamingHttpResponse

from django_structlog_demo_project.taskapp.celery import (
    failing_task,
    nesting_task,
    rejected_task,
    successful_task,
)

logger = structlog.get_logger(__name__)


def enqueue_successful_task(request):
    logger.info("Enqueuing successful task")
    successful_task.apply_async(foo="bar", priority=5)
    return HttpResponse(status=201)


def enqueue_failing_task(request):
    logger.info("Enqueuing failing task")
    failing_task.delay(foo="bar")
    return HttpResponse(status=201)


def enqueue_nesting_task(request):
    logger.info("Enqueuing nesting task")
    nesting_task.delay()
    return HttpResponse(status=201)


def log_with_standard_logger(request):
    logging.getLogger("foreign_logger").info("This is a standard logger")
    return HttpResponse(status=200)


def revoke_task(request):
    async_result = successful_task.apply_async(countdown=1)
    async_result.revoke()
    return HttpResponse(status=201)


def enqueue_unknown_task(request):
    from django_structlog_demo_project.taskapp.celery import unknown_task

    logger.info("Enqueuing unknown task")
    unknown_task.delay()
    return HttpResponse(status=201)


def enqueue_rejected_task(request):
    rejected_task.delay()
    return HttpResponse(status=201)


async def async_view(request):
    for num in range(1, 2):
        await asyncio.sleep(1)
        logger.info(f"This this is an async view {num}")
    return HttpResponse(status=200)


async def async_streaming_response():
    for chunk in range(0, 5):
        await asyncio.sleep(0.5)
        logger.info("streaming_chunk", chunk=chunk)
        yield chunk


def sync_streaming_response():
    for chunk in range(0, 5):
        time.sleep(0.5)
        logger.info("streaming_chunk", chunk=chunk)
        yield chunk


def sync_streaming_view(request):
    logger.info("This this is a sync streaming view")
    return StreamingHttpResponse(sync_streaming_response())


async def async_streaming_view(request):
    logger.info("This this is an async streaming view")
    return StreamingHttpResponse(async_streaming_response())


def raise_exception(request):
    raise Exception("This is a view raising an exception.")

django_structlog_demo_project/users/views.py
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse
from django.views.generic import DetailView, ListView, RedirectView, UpdateView

User = get_user_model()


class UserDetailView(LoginRequiredMixin, DetailView):
    model = User
    slug_field = "username"
    slug_url_kwarg = "username"


user_detail_view = UserDetailView.as_view()


class UserListView(LoginRequiredMixin, ListView):
    model = User
    slug_field = "username"
    slug_url_kwarg = "username"


user_list_view = UserListView.as_view()


class UserUpdateView(LoginRequiredMixin, UpdateView):
    model = User
    fields = ["name"]

    def get_success_url(self):
        return reverse("users:detail", kwargs={"username": self.request.user.username})

    def get_object(self, queryset=None):
        return User.objects.get(username=self.request.user.username)


user_update_view = UserUpdateView.as_view()


class UserRedirectView(LoginRequiredMixin, RedirectView):
    permanent = False

    def get_redirect_url(self, *args, **kwargs):
        return reverse("users:detail", kwargs={"username": self.request.user.username})


user_redirect_view = UserRedirectView.as_view()

django_structlog_demo_project/templates/403_csrf.html
{% extends "base.html" %}

{% block title %}Forbidden (403){% endblock %}

{% block content %}
<h1>Forbidden (403)</h1>

<p>CSRF verification failed. Request aborted.</p>
{% endblock content %}

django_structlog_demo_project/templates/base.html
{% load static i18n %}<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <title>{% block title %}django_structlog_demo_project{% endblock title %}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">

    <link rel="icon" href="{% static 'images/favicons/favicon.ico' %}">

    {% block css %}

    <!-- Latest compiled and minified Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">


    <!-- Your stuff: Third-party CSS libraries go here -->

    <!-- This file stores project-specific CSS -->

    <link href="{% static 'css/project.css' %}" rel="stylesheet">

    {% endblock %}

  </head>

  <body>


  <ul class="nav nav-tabs bg-light">
    <li class="nav-item">
      <a class="nav-link {% if "8000" in request.get_host|urlize %} active {% endif %}" href="http://localhost:8000">runserver_plus</a>
    </li>
    <li class="nav-item">
      <a class="nav-link {% if "8001" in request.get_host|urlize %} active {% endif %}" href="http://localhost:8001">wsgi</a>
    </li>
    <li class="nav-item">
      <a class="nav-link {% if "8002" in request.get_host|urlize %} active {% endif %}" href="http://localhost:8002">asgi</a>
    </li>
  </ul>
    <div class="mb-1">
      <nav class="navbar navbar-expand-md navbar-light">


        <div class="collapse navbar-collapse" id="navbarSupportedContent">

          <ul class="navbar-nav mr-auto">
            <li class="nav-item">
              <a class="nav-link navbar-brand" href="{% url 'home' %}">django_structlog_demo_project</a>
            </li>
            <li class="nav-item active">
              <a class="nav-link" href="{% url 'home' %}">Home</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="{% url 'about' %}">About</a>
            </li>
            {% if request.user.is_authenticated %}
              <li class="nav-item">
                {# URL provided by django-allauth/account/urls.py #}
                <a class="nav-link" href="{% url 'users:detail' request.user.username  %}">{% trans "My Profile" %}</a>
              </li>
              <li class="nav-item">
                {# URL provided by django-allauth/account/urls.py #}
                <a class="nav-link" href="{% url 'account_logout' %}">{% trans "Sign Out" %}</a>
              </li>
            {% else %}
              <li class="nav-item">
                {# URL provided by django-allauth/account/urls.py #}
                <a id="sign-up-link" class="nav-link" href="{% url 'account_signup' %}">{% trans "Sign Up" %}</a>
              </li>
              <li class="nav-item">
                {# URL provided by django-allauth/account/urls.py #}
                <a id="log-in-link" class="nav-link" href="{% url 'account_login' %}">{% trans "Sign In" %}</a>
              </li>
            {% endif %}
          </ul>
        </div>
      </nav>

    </div>

    <div class="container">

      {% if messages %}
          {% for message in messages %}
              <div class="alert {% if message.tags %}alert-{{ message.tags }}{% endif %}">{{ message }}</div>
          {% endfor %}
      {% endif %}

      {% block content %}
        <p>Use this document as a way to quick start any new project.</p>
      {% endblock content %}

    </div> <!-- /container -->

    {% block modal %}{% endblock modal %}

    <!-- Le javascript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    {% block javascript %}

    <!-- Bootstrap JS and its dependencies-->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

    <!-- Your stuff: Third-party javascript libraries go here -->

    <!-- place project specific Javascript in this file -->

    <script src="{% static 'js/project.js' %}"></script>


    {% endblock javascript %}
  </body>
</html>

django_structlog_demo_project/templates/pages/about.html
{% extends "base.html" %}

django_structlog_demo_project/templates/pages/home.html
{% extends "base.html" %}

{% load static i18n %}
{% block javascript %}
  {{ block.super }}

  <script src="{% static 'js/home.js' %}"></script>
{% endblock %}

{% block content %}

  <div class="position-fixed bottom-0 end-0 p-3" style="z-index: 11">
    <div id="toast-container" class="toast-container">
      <div id="toastTemplate" class="toast border " aria-atomic="true">
        <div class="toast-header">
          <strong class="me-auto"></strong>
          <small class="text-muted duration"></small>
          <button type="button" class="btn-close" data-bs-dismiss="toast" aria-label="Close"></button>
        </div>
        <div class="toast-body"></div>
      </div>
    </div>
  </div>
  <div class="col-md-6 offset-md-3">
    <div class="vstack gap-1">
      <div class="card">
        <div class="card-body">
          <h5 class="card-title">Base</h5>
          <div class="vstack gap-1">
            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'raise_exception' %}')">
              Raise exception
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchStreamingUrl('{% url 'sync_streaming_view' %}')">
              Streaming view
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'standard_logger' %}')">
              Standard logger
            </button>
          </div>
        </div>
      </div>
      <div class="card">
        <div class="card-body">
          <h5 class="card-title">Async</h5>
          <div class="vstack gap-1">

            <button
              class="btn btn-outline-success"
              onclick="fetchStreamingUrl('{% url 'async_streaming_view' %}')">
              Async streaming view
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'async_view' %}')">
              Async View
            </button>

            <button
              class="btn btn-outline-danger"
              onclick="cancelAsync()">
              Cancel
            </button>
          </div>
        </div>
      </div>
      <div class="card">
        <div class="card-body">
          <h5 class="card-title">rest-framework</h5>
          <div class="vstack gap-1">
            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'api_view' %}')">
              API View
            </button>
          </div>
        </div>
      </div>
      <div class="card">
        <div class="card-body">
          <h5 class="card-title">ninja</h5>
          <div class="vstack gap-1">
            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'ninja:ninja' %}')">
              API View
            </button>
          </div>
        </div>
      </div>
      <div class="card">
        <div class="card-body">
          <h5 class="card-title">Celery</h5>
          <div class="vstack gap-1">
            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'enqueue_successful_task' %}')">
              Successful task
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'enqueue_failing_task' %}')">
              Failing task
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'enqueue_nesting_task' %}')">
              Nesting task
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'enqueue_unknown_task' %}')">
              Unknown task
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'enqueue_rejected_task' %}')">
              Rejected task
            </button>

            <button
              class="btn btn-outline-success"
              onclick="fetchUrl('{% url 'revoke_task' %}')">
              Revoke task
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

django_structlog_demo_project/templates/users/user_detail.html
{% extends "base.html" %}
{% load static %}

{% block title %}User: {{ object.username }}{% endblock %}

{% block content %}
<div class="container">

  <div class="row">
    <div class="col-sm-12">

      <h2>{{ object.username }}</h2>
      {% if object.name %}
        <p>{{ object.name }}</p>
      {% endif %}
    </div>
  </div>

{% if object == request.user %}
<!-- Action buttons -->
<div class="row">

  <div class="col-sm-12">
    <a class="btn btn-primary" href="{% url 'users:update' %}" role="button">My Info</a>
    <a class="btn btn-primary" href="{% url 'account_email' %}" role="button">E-Mail</a>
    <!-- Your Stuff: Custom user template urls -->
  </div>

</div>
<!-- End Action buttons -->
{% endif %}


</div>
{% endblock content %}

django_structlog_demo_project/templates/users/user_form.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}{{ user.username }}{% endblock %}

{% block content %}
  <h1>{{ user.username }}</h1>
  <form class="form-horizontal" method="post" action="{% url 'users:update' %}">
    {% csrf_token %}
    {{ form|crispy }}
    <div class="control-group">
      <div class="controls">
        <button type="submit" class="btn">Update</button>
      </div>
    </div>
  </form>
{% endblock %}

django_structlog_demo_project/templates/users/user_list.html
{% extends "base.html" %}
{% load static i18n %}
{% block title %}Members{% endblock %}

{% block content %}
<div class="container">
  <h2>Users</h2>

  <div class="list-group">
    {% for user in user_list %}
      <a href="{% url 'users:detail' user.username %}" class="list-group-item">
        <h4 class="list-group-item-heading">{{ user.username }}</h4>
      </a>
    {% endfor %}
  </div>
</div>
{% endblock content %}